<template>
  <div>
    <v-layout>
      <default-spinner-component :loading-message="loadingMessage"
        v-if="gettingAllSalesData"/>
      <v-flex v-if="showSalesForm">
        <v-card id="loginContentContainer"
          class="defaultCardBackground"
          style="margin-bottom:30px;height:auto;min-height:600px">
          <v-progress-linear
            v-if="submitRequested"
            :indeterminate="true"
            height="4"
            color="success"
            background-color="lightSuccess"
            style="height: 4px;position: absolute;top: -16px;">
          </v-progress-linear>
          <v-card-title>
            <h4 style="color:rgb(80, 130, 150)">
              Register sales
            </h4>
          </v-card-title>
          <v-divider></v-divider>
          <form class="login" @submit.prevent="$v.$touch(); onSalesSubmit();">
            <div class="defaultInputContainer"
              style="margin-top:0px;"
              v-bind:class="{ 'form-group--error': $v.itemName.$error }">
              <span style="position: absolute;top: 30px;">
                Item name
              </span>
              <v-select
                :items="allItemsNamesList"
                v-model="itemName"
                label="Select"
                single-line
                style="width:75%;margin-left:90px;height:50px;">
              </v-select>
              <span class="formErrorMessage"
                v-if="$v.itemName.$error && $v.itemName.$dirty"
                style="bottom:0px;">
                Required
              </span>
              <v-icon style="color:#5A5;position: absolute;top: 30px;right: 7%;"
                v-if="$v.itemName.$dirty && !$v.itemName.$invalid">
                check_circle
              </v-icon>
              <v-icon style="color:#FF3D00;position: absolute;top: 30px;right: 7%;"
                v-if="$v.itemName.$error && $v.itemName.$dirty">
                cancel
              </v-icon>
            </div>
            <div v-if="itemName"
              class="defaultInputContainer"
              style="margin-top:0px;"
              v-bind:class="{ 'form-group--error': $v.shopName.$error }">
              <span style="position: absolute;top: 30px;">
                Store name
              </span>
              <v-select
                :items="allStoresList"
                v-model="shopName"
                label="Select"
                single-line
                style="width:75%;margin-left:90px;height:50px;">
              </v-select>
              <span class="formErrorMessage"
                v-if="$v.shopName.$error && $v.shopName.$dirty"
                style="bottom:0px;">
                Required
              </span>
              <v-icon style="color:#5A5;position: absolute;top: 30px;right: 7%;"
                v-if="$v.shopName.$dirty && !$v.shopName.$invalid">
                check_circle
              </v-icon>
              <v-icon style="color:#FF3D00;position: absolute;top: 30px;right: 7%;"
                v-if="$v.shopName.$error && $v.shopName.$dirty">
                cancel
              </v-icon>
            </div>
            <div v-if="shopName"
              class="defaultInputContainer"
              style="margin-top:0px;"
              v-bind:class="{ 'form-group--error': $v.brand.$error }">
              <span style="position: absolute;top: 30px;">
                Brand
              </span>
              <v-select
                :items="allBrandsList"
                v-model="brand"
                label="Select"
                single-line
                style="width:75%;margin-left:90px;height:50px;">
              </v-select>
              <span class="formErrorMessage"
                v-if="$v.brand.$error && $v.brand.$dirty"
                style="bottom:0px;">
                Required
              </span>
              <v-icon style="color:#5A5;position: absolute;top: 30px;right: 7%;"
                v-if="$v.brand.$dirty && !$v.brand.$invalid">
                check_circle
              </v-icon>
              <v-icon style="color:#FF3D00;position: absolute;top: 30px;right: 7%;"
                v-if="$v.brand.$error && $v.brand.$dirty">
                cancel
              </v-icon>
            </div>
            <div v-if="brand"
              class="defaultInputContainer"
              style="margin-top:0px;"
              v-bind:class="{ 'form-group--error': $v.size.$error }">
              <span style="position: absolute;top: 30px;">
                Size
              </span>
              <v-select
                :items="allSizesList"
                v-model="size"
                label="Select"
                single-line
                style="width:75%;margin-left:90px;height:50px;">
              </v-select>
              <span class="formErrorMessage"
                v-if="$v.size.$error && $v.size.$dirty"
                style="bottom:0px;">
                Required
              </span>
              <v-icon style="color:#5A5;position: absolute;top: 30px;right: 7%;"
                v-if="$v.size.$dirty && !$v.size.$invalid">
                check_circle
              </v-icon>
              <v-icon style="color:#FF3D00;position: absolute;top: 30px;right: 7%;"
                v-if="$v.size.$error && $v.size.$dirty">
                cancel
              </v-icon>
            </div>
            <div v-if="size" class="defaultInputContainer"
              v-bind:class="{ 'form-group--error': $v.salesPrice.$error }">
              <input id="salesPrice"
                class="inputDefault"
                type="text"
                v-model.trim="salesPrice"
                @input="$v.salesPrice.$touch()"
                v-on:input="$v.salesPrice.$touch"
                v-bind:class="{
                  error: $v.salesPrice.$error,
                  valid: $v.salesPrice.$dirty && !$v.salesPrice.$invalid
              }"/>
              <label for="salesPrice"
                class="defaultInputPlaceholder">
                Sales price
              </label>
              <span class="formErrorMessage"
                v-if="$v.salesPrice.$error && $v.salesPrice.$dirty">
                Required
              </span>
              <v-icon style="color:#5A5"
                v-if="$v.salesPrice.$dirty && !$v.salesPrice.$invalid">
                check_circle
              </v-icon>
              <v-icon style="color:#FF3D00"
                v-if="$v.salesPrice.$error && $v.salesPrice.$dirty">
                cancel
              </v-icon>
            </div>
            <div v-if="salesPrice"
              class="defaultInputContainer"
              style="margin-top:0px;"
              v-bind:class="{ 'form-group--error': $v.seller.$error }">
              <span style="position: absolute;top: 30px;">
                Seller
              </span>
              <v-select
                :items="fullSellerNamesList"
                v-model="seller"
                label="Select"
                single-line
                style="width:75%;margin-left:90px;height:50px;">
              </v-select>
              <span class="formErrorMessage"
                v-if="$v.seller.$error && $v.seller.$dirty"
                style="bottom:0px;">
                Required
              </span>
              <v-icon style="color:#5A5;position: absolute;top: 30px;right: 7%;"
                v-if="$v.seller.$dirty && !$v.seller.$invalid">
                check_circle
              </v-icon>
              <v-icon style="color:#FF3D00;position: absolute;top: 30px;right: 7%;"
                v-if="$v.seller.$error && $v.seller.$dirty">
                cancel
              </v-icon>
            </div>
            <br/>
            <v-btn v-if="seller"
              depressed
              block
              color="darkSecondary"
              dark
              type="submit"
              style="width:90%;margin:0 auto;">
              CREATE SALES
            </v-btn>
            <br/><br/>
          </form>
        </v-card>
      </v-flex>
    </v-layout>
  </div>
</template>
<script>
import { required } from 'vuelidate/lib/validators'
import axios from 'axios'
import DefaultSpinnerComponent from './../common/spinner.vue'
export default {
  name: 'SalesComponent',
  components: {
    DefaultSpinnerComponent
  },
  data: () => ({
    itemName: '',
    shopName: '',
    brand: '',
    size: '',
    salesPrice: '',
    seller: '',
    submitRequested: false,
    gettingAllSalesData: false,
    showSalesForm: false,
    allItemsNamesList: [],
    allSellerNamesList: [],
    allStoresList: [],
    allBrandsList: [],
    allSizesList: [],
    loadingMessage: 'Loading sales data',
    itemInformation: {}
  }),
  computed: {
    fullSellerNamesList () {
      return this.allSellerNamesList.map(element => {
        return element.firstName + ' ' + element.lastName
      })
    }
  },
  methods: {
    onSalesSubmit () {
      let salesRequestData = {
        name: this.itemName,
        shopName: this.shopName,
        brand: this.brand,
        size: this.size,
        salesPrice: this.salesPrice,
        seller: this.seller.split(' ')[0]
      }
      this.submitRequested = true
      axios.post('sales', salesRequestData)
        .then(response => {
          setTimeout(() => {
            this.submitRequested = false
            this.$store.commit('SHOW_SUCCESS_SNACK_BAR', 'Sales operation succesfull')
          }, 2000)
        })
        .catch(error => {
          this.$store.commit('SHOW_ERROR_SNACK_BAR', 'Error in generating sales: ' + error)
        })
    }
  },
  watch: {
    itemName (val) {
      if (val !== '') {
        axios.get('item/' + val)
          .then(response => {
            let storesList = []
            this.itemInformation = response.data
            response.data.itemInfo.forEach(element => {
              storesList.push(element.shopName)
            })
            this.allStoresList = storesList
          })
          .catch(error => {
            this.$store.commit('SHOW_ERROR_SNACK_BAR', 'Error in getting item information: ' + error)
          })
      }
    },
    shopName (val) {
      if (val !== '') {
        let itemInformation = this.itemInformation
        let brandsList = []
        itemInformation.itemInfo.forEach(element => {
          element.bransAndSize.forEach(brandElement => {
            brandsList.push(brandElement.brand)
          })
        })
        this.allBrandsList = brandsList
      }
    },
    brand (val) {
      if (val !== '') {
        let itemInformation = this.itemInformation
        let sizesList = []
        itemInformation.itemInfo.forEach(element => {
          element.bransAndSize.forEach(brandElement => {
            brandElement.sizes.forEach(sizeElement => {
              if (sizesList.includes(sizeElement.size) === false) {
                sizesList.push(sizeElement.size)
              }
            })
          })
        })
        this.allSizesList = sizesList
      }
    }
  },
  created () {
    this.gettingAllSalesData = true
    axios.get('/all_item_names')
      .then(response => {
        this.allItemsNamesList = response.data
        return axios.get('/get_all_seller_names')
      }, error => {
        this.$store.commit('SHOW_ERROR_SNACK_BAR', 'Error in getting all item name list: ' + error)
        this.allItemsNamesList = []
        this.gettingAllSalesData = false
        this.showSalesForm = false
      })
      .then(response => {
        setTimeout(() => {
          this.allSellerNamesList = response.data
          this.gettingAllSalesData = false
          this.showSalesForm = true
        }, 2000)
      }, error => {
        this.$store.commit('SHOW_ERROR_SNACK_BAR', 'Error in getting all seller name list: ' + error)
        this.allSellerNamesList = []
        this.gettingAllSalesData = false
        this.showSalesForm = false
      })
  },
  validations: {
    itemName: {
      required
    },
    shopName: {
      required
    },
    brand: {
      required
    },
    size: {
      required
    },
    salesPrice: {
      required
    },
    seller: {
      required
    }
  }
}
</script>
<style>
.error {
  border: 1px solid #FF3D00 !important;
  background: #ffffff !important;
}

.error:focus {
  outline-color: #F99;
}

.valid {
  border:1px solid #43A047 !important;
}

.valid:focus {
  outline-color: #43A047;
}
.formErrorMessage{
    color: #FF3D00;
    font-size: 14px;
    font-family: Roboto;
    position: absolute;
    left: 10px;
    bottom: -10px;
}

.login{
    padding-top: 1px;
}
#loginContentContainer{
  width: 50%;
  display: block;
  margin: 0 auto;
}
.loginContainer{
  background: #eeeeee !important;
  margin-top: 10vh;
}
.loginText{
    background: #F5F5F5;
    border: 1px solid #4D4D4D;
    border-radius: 4px;
    padding: 12px;
}
.defaultInputContainer{
  width: 100%;
    padding: 10px;
    position: relative;
    margin: 0 auto;
    margin-left: 3%;
    margin-top: 20px;
    color: #757575;
}
.ellaText{
  color: #a53a00;
}
@media only screen and (max-width: 1150px){
  #loginContentContainer{
    width: 50% !important;
  }
}
@media only screen and (max-width: 800px){
  #loginContentContainer{
    width: 70% !important;
  }
}
@media only screen and (max-width: 550px){
  #loginContentContainer{
    width: 80% !important;
  }
}
@media only screen and (max-width: 480px){
  #loginContentContainer{
    width: 96% !important;
  }
}
</style>
